package com.issenda.passthepie;

import android.app.*;
import android.content.*;
import android.content.res.*;
import android.os.*;
import android.view.*;
import android.view.inputmethod.EditorInfo;
import android.widget.*;
import java.io.*;
import java.lang.ref.*;
import android.opengl.*;

public class MainActivity extends Activity {
	TextView passe;
	TextView webe;
	TextView keye;
	Button genb;
	Button copyb;
	TextView loade;
	Button loadb;

	@Override
	public void onCreate(Bundle icicle) {
		super.onCreate(icicle);
		setContentView(R.layout.main);

		passe = (TextView)this.findViewById(R.id.passe);
		webe = (TextView)this.findViewById(R.id.webe);
		keye = (TextView)this.findViewById(R.id.keye);

		genb = (Button)this.findViewById(R.id.genb);
		genb.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				AssetManager mngr = getAssets();
				try {
				InputStream is = mngr.open("ptp");
				FileOutputStream output = new FileOutputStream("/data/data/com.issenda.passthepie/ptp"); 
				byte[] buffer = new byte[1024];
				int len = 0;
				while ((len = is.read(buffer)) != -1) {
    					output.write(buffer, 0, len);
				}
				output.close();
				}
				catch(IOException p) {}
				try {
					java.lang.Process process = Runtime.getRuntime().exec("chmod 755 /data/data/com.issenda.passthepie/ptp");
					BufferedReader reader = new BufferedReader(new InputStreamReader(process.getInputStream()));
					int read;
					char[] buffers = new char[4096];
					StringBuffer outputes = new StringBuffer();
					while ((read = reader.read(buffers)) > 0) {
						outputes.append(buffers, 0, read);
					}
					keye.setText(outputes.toString());
					reader.close();
					try {
						process.waitFor();
					}
					catch (InterruptedException u) {}
				}
				catch (IOException e) {}
				try {
				java.lang.Process process = new ProcessBuilder()
				    .command("/data/data/com.issenda.passthepie/ptp", passe.getText().toString(), webe.getText().toString())
					.redirectErrorStream(true)
					.start();
				BufferedReader reader = new BufferedReader(new InputStreamReader(process.getInputStream()));
				int read;
				char[] buffers = new char[4096];
				StringBuffer outputs = new StringBuffer();
				while ((read = reader.read(buffers)) > 0) {
					outputs.append(buffers, 0, read);
				}
				reader.close();
				try {
				process.waitFor();
				}
				catch (InterruptedException u) {}
				    String abc = new String();
					abc = outputs.toString();
					keye.setText(abc);
				}
				catch (IOException e) {}
			}
		});
		copyb = (Button)this.findViewById(R.id.copyb);
		copyb.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				ClipboardManager clipboard = (ClipboardManager)
        			getSystemService(Context.CLIPBOARD_SERVICE);
				ClipData clip = ClipData.newPlainText("simple text",keye.getText().toString());
				clipboard.setPrimaryClip(clip);
				Toast.makeText(getApplicationContext(), "Password Copied", Toast.LENGTH_SHORT).show();
			}
		});
		TextView.OnEditorActionListener gengo = new TextView.OnEditorActionListener() {
		public boolean onEditorAction(TextView passe, int actionId, KeyEvent event) {
			if (actionId == EditorInfo.IME_NULL && event.getKeyCode() == KeyEvent.KEYCODE_ENTER) {
				webe.requestFocus();
			}
			return true;
		}
		};
		passe.setOnEditorActionListener(gengo);
		TextView.OnEditorActionListener webgo = new TextView.OnEditorActionListener() {
			public boolean onEditorAction(TextView webe, int actionId, KeyEvent event) {
				if (actionId == EditorInfo.IME_NULL && event.getKeyCode() == KeyEvent.KEYCODE_ENTER) {
					genb.performClick();
				}
				return true;
			}
		};
		webe.setOnEditorActionListener(webgo);
	}
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.menu, menu);
		return true;
	}
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
			case R.id.importm:
				setContentView(R.layout.edit);
				loade = (TextView)this.findViewById(R.id.loade);
				loadb = (Button)this.findViewById(R.id.loadb);
				loadb.setOnClickListener(new View.OnClickListener() {
						public void onClick(View v) {
							try {
								File root = Environment.getExternalStorageDirectory();
                                InputStream in = new FileInputStream(root + "/" + loade.getText().toString());
								OutputStream out = new FileOutputStream(root + "/.PTPie");
								byte[] buf = new byte[1024];
								int len;
								while ((len = in.read(buf)) > 0) {
									out.write(buf, 0, len);
								}
								in.close();
								out.close();
								Toast.makeText(getApplicationContext(), "File Imported", Toast.LENGTH_SHORT).show();
						    } catch (IOException err) {
								Toast.makeText(getApplicationContext(), "File Not Found", Toast.LENGTH_SHORT).show();
							}
						}
					});
				return true;
			case R.id.aboutm:
				setContentView(R.layout.info);
				return true;
			default:
				return super.onOptionsItemSelected(item);
		}
	}
	public boolean onKeyDown(int keyCode, KeyEvent event){
		if (keyCode == KeyEvent.KEYCODE_BACK) {
			try {
				this.findViewById(R.id.genb).getVisibility();
			} catch (Exception err) {
				recreate();
		        //setContentView(R.layout.main);
				return true;
			}
			    finish();
		}
		if (keyCode == KeyEvent.KEYCODE_MENU) {
			openOptionsMenu();
		}
		return true;
	}
}
