#include <QtGui> 
#include "ptpgui.h"

// if we include <QtGui> there is no need to include every class used: <QString>, <QFileDialog>,...

extern int addseed(char* seed);
extern char* genseed();
extern char* pass(char* password, char* website);
extern int amhohwa(char* filee, char* password);

myQtMai::myQtMai(QWidget *parent)
{
	setupUi( this ); // this sets up GUI


	// signals/slots mechanism in action
	connect( GenerateButton, SIGNAL( clicked() ), this, SLOT( Generate() ) ); 
	connect( actionSeed, SIGNAL( triggered() ), this, SLOT( OpenSeed() ) ); 
	connect( actionCrypt, SIGNAL( triggered() ), this, SLOT( OpenCrypt() ) ); 
	connect( actionAbout, SIGNAL( triggered() ), this, SLOT( OpenAbout() ) ); 
}

myQtDia::myQtDia(QWidget *parent)
{
	setupUi( this ); // this sets up GUI


	// signals/slots mechanism in action
	connect( RandomButton, SIGNAL( clicked() ), this, SLOT( Random() ) ); 
	connect( ExportButton, SIGNAL( clicked() ), this, SLOT( Export() ) ); 
	connect( SaveButton, SIGNAL( clicked() ), this, SLOT( Save() ) ); 
	QString path = getenv("HOME");
	path += "/.PTPie";
	QFile file(path);
	file.open(QIODevice::ReadOnly | QIODevice::Text);
	QTextStream in(&file);
	SeedTextEdit->setPlainText(in.readLine());
	file.close();
}


void myQtMai::Generate()
{
	KeyTextEdit->setPlainText(pass((PassEdit->text()).toLatin1().data(), (WebEdit->text()).toLatin1().data()));
}


void myQtMai::OpenSeed()
{
	myQtDia *dialog = new myQtDia;
	dialog->show();
}

void myQtMai::OpenCrypt()
{
	if (KeyTextEdit->toPlainText() == "")
			QMessageBox::about(this, "Warning",
        	                 "A key must be generated\n"
        	                 "for you to open a file.\n");
	else
	{
	QString fileName;
	fileName = QFileDialog::getOpenFileName(this,
		tr("Open File"), "~", tr("Any Files (*.*)"));
	if (fileName != "" && fileName != NULL)
		amhohwa(fileName.toLatin1().data(), (KeyTextEdit->toPlainText()).toLatin1().data());
	}
}

void myQtMai::OpenAbout() 
{
	QMessageBox::about(this, "About Pass The Pie 2.0qt",
        	                 "This work is licensed under the\n"
        	                 "Gnu General Public License Version 3.\n"
        	                 "To view a copy of this license,\n"
        	                 "visit http://www.gnu.org/licenses/gpl-3.0.txt.\n"
        	                 "Those who use this work must clearly show\n"
        	                 "to the users of the derivative works that\n"
        	                 "it was based on work by Cafeinoz from\n"
        	                 "Issenda Productions.\n");
}

void myQtDia::Random()
{
	SeedTextEdit->setPlainText(genseed());
}


void myQtDia::Export()
{
	QString path;
	
	path = QFileDialog::getSaveFileName(
		this,
		"Choose a file to save",
		QString::null,
		QString::null);
	QFile file(path);
	file.open(QIODevice::WriteOnly | QIODevice::Text);
	QTextStream out(&file);
	out << (SeedTextEdit->toPlainText()).toLatin1().data();
	file.close(); 
}


void myQtDia::Save()
{
	addseed((SeedTextEdit->toPlainText()).toLatin1().data());
	close();
}
