const string ptpui = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<interface>
  <!-- interface-requires gtk+ 3.0 -->
  <object class=\"GtkImage\" id=\"image1\">
    <property name=\"visible\">True</property>
    <property name=\"can_focus\">False</property>
    <property name=\"stock\">gtk-execute</property>
  </object>
  <object class=\"GtkImage\" id=\"image2\">
    <property name=\"visible\">True</property>
    <property name=\"can_focus\">False</property>
    <property name=\"stock\">gtk-execute</property>
  </object>
  <object class=\"GtkWindow\" id=\"main_window\">
    <property name=\"can_focus\">False</property>
    <property name=\"title\" translatable=\"yes\">Pass the Pie</property>
    <property name=\"default_width\">440</property>
    <property name=\"default_height\">250</property>
    <child>
      <object class=\"GtkBox\" id=\"box1\">
        <property name=\"visible\">True</property>
        <property name=\"can_focus\">False</property>
        <property name=\"orientation\">vertical</property>
        <child>
          <object class=\"GtkMenuBar\" id=\"menubar1\">
            <property name=\"visible\">True</property>
            <property name=\"can_focus\">False</property>
            <child>
              <object class=\"GtkMenuItem\" id=\"menuitem1\">
                <property name=\"use_action_appearance\">False</property>
                <property name=\"visible\">True</property>
                <property name=\"can_focus\">False</property>
                <property name=\"label\" translatable=\"yes\">_File</property>
                <property name=\"use_underline\">True</property>
                <child type=\"submenu\">
                  <object class=\"GtkMenu\" id=\"menu1\">
                    <property name=\"visible\">True</property>
                    <property name=\"can_focus\">False</property>
                    <child>
                      <object class=\"GtkImageMenuItem\" id=\"menu_seed\">
                        <property name=\"label\" translatable=\"yes\">Seed</property>
                        <property name=\"visible\">True</property>
                        <property name=\"can_focus\">False</property>
                        <property name=\"image\">image1</property>
                        <property name=\"use_stock\">False</property>
                      </object>
                    </child>
                    <child>
                      <object class=\"GtkImageMenuItem\" id=\"menu_crypt\">
                        <property name=\"label\" translatable=\"yes\">En/Decrypt File</property>
                        <property name=\"visible\">True</property>
                        <property name=\"can_focus\">False</property>
                        <property name=\"image\">image2</property>
                        <property name=\"use_stock\">False</property>
                      </object>
                    </child>
                    <child>
                      <object class=\"GtkSeparatorMenuItem\" id=\"separatormenuitem1\">
                        <property name=\"use_action_appearance\">False</property>
                        <property name=\"visible\">True</property>
                        <property name=\"can_focus\">False</property>
                      </object>
                    </child>
                    <child>
                      <object class=\"GtkImageMenuItem\" id=\"menu_quit\">
                        <property name=\"label\">gtk-quit</property>
                        <property name=\"use_action_appearance\">False</property>
                        <property name=\"visible\">True</property>
                        <property name=\"can_focus\">False</property>
                        <property name=\"use_underline\">True</property>
                        <property name=\"use_stock\">True</property>
                      </object>
                    </child>
                  </object>
                </child>
              </object>
            </child>
            <child>
              <object class=\"GtkMenuItem\" id=\"menuitem4\">
                <property name=\"use_action_appearance\">False</property>
                <property name=\"visible\">True</property>
                <property name=\"can_focus\">False</property>
                <property name=\"label\" translatable=\"yes\">_Help</property>
                <property name=\"use_underline\">True</property>
                <child type=\"submenu\">
                  <object class=\"GtkMenu\" id=\"menu3\">
                    <property name=\"visible\">True</property>
                    <property name=\"can_focus\">False</property>
                    <child>
                      <object class=\"GtkImageMenuItem\" id=\"menu_about\">
                        <property name=\"label\">gtk-about</property>
                        <property name=\"use_action_appearance\">False</property>
                        <property name=\"visible\">True</property>
                        <property name=\"can_focus\">False</property>
                        <property name=\"use_underline\">True</property>
                        <property name=\"use_stock\">True</property>
                      </object>
                    </child>
                  </object>
                </child>
              </object>
            </child>
          </object>
          <packing>
            <property name=\"expand\">False</property>
            <property name=\"fill\">True</property>
            <property name=\"position\">0</property>
          </packing>
        </child>
        <child>
          <object class=\"GtkLabel\" id=\"label1\">
            <property name=\"visible\">True</property>
            <property name=\"can_focus\">False</property>
            <property name=\"xalign\">0</property>
            <property name=\"label\" translatable=\"yes\">Type in a master password and website name to generate
a password that can be used on that site.</property>
            <property name=\"wrap\">True</property>
            <property name=\"wrap_mode\">word-char</property>
            <attributes>
              <attribute name=\"weight\" value=\"bold\"/>
            </attributes>
          </object>
          <packing>
            <property name=\"expand\">False</property>
            <property name=\"fill\">True</property>
            <property name=\"position\">1</property>
          </packing>
        </child>
        <child>
          <object class=\"GtkGrid\" id=\"entry_group\">
            <property name=\"visible\">True</property>
            <property name=\"can_focus\">False</property>
            <child>
              <object class=\"GtkLabel\" id=\"pass_label\">
                <property name=\"visible\">True</property>
                <property name=\"can_focus\">False</property>
                <property name=\"label\" translatable=\"yes\">Password:</property>
              </object>
              <packing>
                <property name=\"left_attach\">0</property>
                <property name=\"top_attach\">0</property>
                <property name=\"width\">1</property>
                <property name=\"height\">1</property>
              </packing>
            </child>
            <child>
              <object class=\"GtkLabel\" id=\"web_label\">
                <property name=\"visible\">True</property>
                <property name=\"can_focus\">False</property>
                <property name=\"label\" translatable=\"yes\">Website:</property>
              </object>
              <packing>
                <property name=\"left_attach\">0</property>
                <property name=\"top_attach\">1</property>
                <property name=\"width\">1</property>
                <property name=\"height\">1</property>
              </packing>
            </child>
            <child>
              <object class=\"GtkLabel\" id=\"key_label\">
                <property name=\"visible\">True</property>
                <property name=\"can_focus\">False</property>
                <property name=\"label\" translatable=\"yes\">Key:</property>
              </object>
              <packing>
                <property name=\"left_attach\">0</property>
                <property name=\"top_attach\">2</property>
                <property name=\"width\">1</property>
                <property name=\"height\">1</property>
              </packing>
            </child>
            <child>
              <object class=\"GtkEntry\" id=\"pass_entry\">
                <property name=\"visible\">True</property>
                <property name=\"can_focus\">True</property>
                <property name=\"has_focus\">True</property>
                <property name=\"is_focus\">True</property>
                <property name=\"visibility\">False</property>
                <property name=\"invisible_char\">•</property>
                <property name=\"activates_default\">True</property>
                <property name=\"placeholder_text\">12345</property>
              </object>
              <packing>
                <property name=\"left_attach\">1</property>
                <property name=\"top_attach\">0</property>
                <property name=\"width\">1</property>
                <property name=\"height\">1</property>
              </packing>
            </child>
            <child>
              <object class=\"GtkEntry\" id=\"web_entry\">
                <property name=\"visible\">True</property>
                <property name=\"can_focus\">True</property>
                <property name=\"invisible_char\">•</property>
                <property name=\"activates_default\">True</property>
                <property name=\"placeholder_text\">google</property>
              </object>
              <packing>
                <property name=\"left_attach\">1</property>
                <property name=\"top_attach\">1</property>
                <property name=\"width\">1</property>
                <property name=\"height\">1</property>
              </packing>
            </child>
            <child>
              <object class=\"GtkTextView\" id=\"key_text\">
                <property name=\"visible\">True</property>
                <property name=\"can_focus\">True</property>
                <property name=\"hexpand\">True</property>
                <property name=\"vexpand\">True</property>
                <property name=\"editable\">False</property>
              </object>
              <packing>
                <property name=\"left_attach\">1</property>
                <property name=\"top_attach\">2</property>
                <property name=\"width\">1</property>
                <property name=\"height\">1</property>
              </packing>
            </child>
          </object>
          <packing>
            <property name=\"expand\">False</property>
            <property name=\"fill\">True</property>
            <property name=\"position\">2</property>
          </packing>
        </child>
        <child>
          <object class=\"GtkButtonBox\" id=\"button_box\">
            <property name=\"visible\">True</property>
            <property name=\"can_focus\">False</property>
            <property name=\"homogeneous\">True</property>
            <property name=\"layout_style\">spread</property>
            <child>
              <object class=\"GtkButton\" id=\"generate_button\">
                <property name=\"label\" translatable=\"yes\">Generate</property>
                <property name=\"use_action_appearance\">False</property>
                <property name=\"visible\">True</property>
                <property name=\"can_focus\">True</property>
                <property name=\"can_default\">True</property>
                <property name=\"has_default\">True</property>
                <property name=\"receives_default\">True</property>
                <property name=\"use_action_appearance\">False</property>
              </object>
              <packing>
                <property name=\"expand\">False</property>
                <property name=\"fill\">True</property>
                <property name=\"position\">1</property>
              </packing>
            </child>
            <child>
              <object class=\"GtkButton\" id=\"copy_button\">
                <property name=\"label\" translatable=\"yes\">Copy</property>
                <property name=\"use_action_appearance\">False</property>
                <property name=\"visible\">True</property>
                <property name=\"can_focus\">True</property>
                <property name=\"receives_default\">True</property>
                <property name=\"use_action_appearance\">False</property>
              </object>
              <packing>
                <property name=\"expand\">False</property>
                <property name=\"fill\">True</property>
                <property name=\"position\">2</property>
              </packing>
            </child>
            <child>
              <object class=\"GtkButton\" id=\"quit_button\">
                <property name=\"label\" translatable=\"yes\">Quit</property>
                <property name=\"use_action_appearance\">False</property>
                <property name=\"visible\">True</property>
                <property name=\"can_focus\">True</property>
                <property name=\"receives_default\">True</property>
                <property name=\"use_action_appearance\">False</property>
              </object>
              <packing>
                <property name=\"expand\">False</property>
                <property name=\"fill\">True</property>
                <property name=\"position\">3</property>
              </packing>
            </child>
          </object>
          <packing>
            <property name=\"expand\">False</property>
            <property name=\"fill\">True</property>
            <property name=\"position\">3</property>
          </packing>
        </child>
      </object>
    </child>
  </object>
</interface>
";

const string seedui = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<interface>
  <!-- interface-requires gtk+ 3.0 -->
  <object class=\"GtkWindow\" id=\"seed_window\">
    <property name=\"can_focus\">False</property>
    <property name=\"title\" translatable=\"yes\">Seed</property>
    <property name=\"default_width\">440</property>
    <property name=\"default_height\">250</property>
    <child>
      <object class=\"GtkBox\" id=\"box1\">
        <property name=\"visible\">True</property>
        <property name=\"can_focus\">False</property>
        <property name=\"orientation\">vertical</property>
        <child>
          <object class=\"GtkLabel\" id=\"label1\">
            <property name=\"visible\">True</property>
            <property name=\"can_focus\">False</property>
            <property name=\"xalign\">0</property>
            <property name=\"yalign\">0</property>
            <property name=\"label\" translatable=\"yes\">Seed:</property>
            <attributes>
              <attribute name=\"font-desc\" value=\"Sans 10\"/>
            </attributes>
          </object>
          <packing>
            <property name=\"expand\">False</property>
            <property name=\"fill\">True</property>
            <property name=\"position\">0</property>
          </packing>
        </child>
        <child>
          <object class=\"GtkTextView\" id=\"seed_box\">
            <property name=\"visible\">True</property>
            <property name=\"can_focus\">True</property>
            <property name=\"hexpand\">True</property>
            <property name=\"vexpand\">True</property>
            <property name=\"wrap_mode\">char</property>
          </object>
          <packing>
            <property name=\"expand\">True</property>
            <property name=\"fill\">True</property>
            <property name=\"position\">1</property>
          </packing>
        </child>
        <child>
          <object class=\"GtkButtonBox\" id=\"buttonbox1\">
            <property name=\"visible\">True</property>
            <property name=\"can_focus\">False</property>
            <property name=\"spacing\">3</property>
            <property name=\"layout_style\">end</property>
            <child>
              <object class=\"GtkButton\" id=\"seed_button\">
                <property name=\"label\" translatable=\"yes\">Random</property>
                <property name=\"visible\">True</property>
                <property name=\"can_focus\">True</property>
                <property name=\"receives_default\">True</property>
              </object>
              <packing>
                <property name=\"expand\">False</property>
                <property name=\"fill\">True</property>
                <property name=\"position\">0</property>
              </packing>
            </child>
            <child>
              <object class=\"GtkButton\" id=\"export_button\">
                <property name=\"label\" translatable=\"yes\">Export</property>
                <property name=\"visible\">True</property>
                <property name=\"can_focus\">True</property>
                <property name=\"receives_default\">True</property>
              </object>
              <packing>
                <property name=\"expand\">False</property>
                <property name=\"fill\">True</property>
                <property name=\"position\">1</property>
              </packing>
            </child>
            <child>
              <object class=\"GtkButton\" id=\"quit_button\">
                <property name=\"label\" translatable=\"yes\">Save</property>
                <property name=\"visible\">True</property>
                <property name=\"can_focus\">True</property>
                <property name=\"receives_default\">True</property>
              </object>
              <packing>
                <property name=\"expand\">False</property>
                <property name=\"fill\">True</property>
                <property name=\"position\">2</property>
              </packing>
            </child>
          </object>
          <packing>
            <property name=\"expand\">False</property>
            <property name=\"fill\">True</property>
            <property name=\"pack_type\">end</property>
            <property name=\"position\">2</property>
          </packing>
        </child>
      </object>
    </child>
  </object>
</interface>
";

const string aboutui = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<interface>
  <!-- interface-requires gtk+ 3.0 -->
  <object class=\"GtkAboutDialog\" id=\"about_window\">
    <property name=\"can_focus\">False</property>
    <property name=\"border_width\">5</property>
    <property name=\"window_position\">center</property>
    <property name=\"type_hint\">dialog</property>
    <property name=\"program_name\">Pass the Pie</property>
    <property name=\"version\">2.0</property>
    <property name=\"copyright\" translatable=\"yes\">(C) 2012 Cafeinoz</property>
    <property name=\"license\" translatable=\"yes\">This work is licensed under the
Gnu General Public License Version 3.
To view a copy of this license,
visit http://www.gnu.org/licenses/gpl-3.0.txt.
Those who use this work must clearly show
to the users of the derivative works that
it was based on work by Cafeinoz from
Issenda Productions.</property>
    <property name=\"authors\">Cafeinoz from Issenda Productions</property>
    <property name=\"logo\">./pass_the_pie_icon.png</property>
    <property name=\"license_type\">custom</property>
    <child internal-child=\"vbox\">
      <object class=\"GtkBox\" id=\"aboutdialog-vbox1\">
        <property name=\"can_focus\">False</property>
        <property name=\"orientation\">vertical</property>
        <property name=\"spacing\">2</property>
        <child internal-child=\"action_area\">
          <object class=\"GtkButtonBox\" id=\"aboutdialog-action_area1\">
            <property name=\"can_focus\">False</property>
            <property name=\"layout_style\">end</property>
          </object>
          <packing>
            <property name=\"expand\">False</property>
            <property name=\"fill\">True</property>
            <property name=\"pack_type\">end</property>
            <property name=\"position\">0</property>
          </packing>
        </child>
        <child>
          <placeholder/>
        </child>
      </object>
    </child>
  </object>
</interface>
";
